



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>poj2762 缩点+topo排序</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">poj2762 缩点+topo排序</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-15 17:22:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>Going from u to v or from v to u?</div>
<div>
<table>
<tbody>
<tr>
<td><strong>Time Limit:</strong>&nbsp;2000MS</td>
<td>&nbsp;</td>
<td><strong>Memory Limit:</strong>&nbsp;65536K</td>
</tr>
<tr>
<td><strong>Total Submissions:</strong>&nbsp;16486</td>
<td>&nbsp;</td>
<td><strong>Accepted:</strong>&nbsp;4386</td>
</tr>
</tbody>
</table>
</div>
<p>Description</p>
<div>In order to make their sons brave, Jiajia and Wind take them to a big cave. The cave has n rooms, and one-way corridors connecting some rooms. Each time, Wind choose two rooms x and y, and ask one of their little sons go from one to the other. The son can either go from x to y, or from y to x. Wind promised that her tasks are all possible, but she actually doesn't know how to decide if a task is possible. To make her life easier, Jiajia decided to choose a cave in which every pair of rooms is a possible task. Given a cave, can you tell Jiajia whether Wind can randomly choose two rooms without worrying about anything?</div>
<p>Input</p>
<div>The first line contains a single integer T, the number of test cases. And followed T cases.</p>
<p>The first line for each case contains two integers n, m(0 &lt; n &lt; 1001,m &lt; 6000), the number of rooms and corridors in the cave. The next m lines each contains two integers u and v, indicating that there is a corridor connecting room u and room v directly.</p></div>
<p>Output</p>
<div>The output should contain T lines. Write 'Yes' if the cave has the property stated above, or 'No' otherwise.</div>
<p>Sample Input</p>
<pre class="prettyprint linenums">1<br />
3 3<br />
1 2<br />
2 3<br />
3 1
</pre>
<p>Sample Output</p>
<pre class="prettyprint linenums">Yes
</pre>
</div>
<div>&nbsp; &nbsp; &nbsp;</div>
<div>题意:</div>
<div>有一张有向图，然后问对于任意的2个点，是否存在x可以到达y，或者y能够到达x。</div>
<div>&nbsp;</div>
<div>思路:</div>
<div>可以先强连通缩点，这样就没有环的情况。然后这样就是一张新的图。也就是相当于在新的图中判断任意2个点能否存在一条路径。这可以用topo排序来解决。如果存在2个点，他们的入度为0，说明这2个点是不能相互到达的。</div>
<div>&nbsp;</div>
<div>
<pre class="prettyprint linenums">/*<br />
 * Author:  sweat123<br />
 * Created Time:  2016/6/25 12:33:09<br />
 * File Name: main.cpp<br />
 */<br />
#include&lt;set&gt;<br />
#include&lt;map&gt;<br />
#include&lt;queue&gt;<br />
#include&lt;stack&gt;<br />
#include&lt;cmath&gt;<br />
#include&lt;string&gt;<br />
#include&lt;vector&gt;<br />
#include&lt;cstdio&gt;<br />
#include&lt;time.h&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;iostream&gt;<br />
#include&lt;algorithm&gt;<br />
#define INF 1&lt;&lt;30<br />
#define MOD 1000000007<br />
#define ll long long<br />
#define lson l,m,rt&lt;&lt;1<br />
#define rson m+1,r,rt&lt;&lt;1|1<br />
#define pi acos(-1.0)<br />
using namespace std;<br />
const int MAXN = ;<br />
struct node{<br />
    int from;<br />
    int to;<br />
    int next;<br />
}edge[MAXN*];<br />
int pre[MAXN],vis[MAXN],dfn[MAXN],low[MAXN],n,m,ind;<br />
int f[MAXN],num,k;<br />
stack&lt;int&gt;s;<br />
void add(int x,int y){<br />
    edge[ind].from = x;<br />
    edge[ind].to = y;<br />
    edge[ind].next = pre[x];<br />
    pre[x] = ind ++;<br />
}<br />
void dfs(int rt){<br />
    vis[rt] = ;<br />
    dfn[rt] = low[rt] = ++k;<br />
    s.push(rt);<br />
    for(int i = pre[rt]; i != -; i = edge[i].next){<br />
        int t = edge[i].to;<br />
        if(!dfn[t]){<br />
            dfs(t);<br />
            low[rt] = min(low[rt],low[t]);<br />
        } else if(vis[t]){<br />
            low[rt] = min(low[rt],dfn[t]);<br />
        }<br />
    }<br />
    if(low[rt] == dfn[rt]){<br />
        ++ num;<br />
        while(!s.empty()){<br />
            int tp = s.top();<br />
            s.pop();<br />
            vis[tp] = ;<br />
            f[tp] = num;<br />
            if(tp == rt)break;<br />
        }<br />
    }<br />
}<br />
int x[MAXN],y[MAXN],ans,in[MAXN];<br />
int ok(){<br />
    queue&lt;int&gt;q;<br />
    for(int i = ; i &lt;= num; i++){<br />
        if(in[i] == ){<br />
            q.push(i);<br />
        }<br />
    }<br />
    if(q.size() &gt; )return ;<br />
    while(!q.empty()){<br />
        int tp = q.front();<br />
        q.pop();<br />
        for(int i = pre[tp]; i != -; i = edge[i].next){<br />
            int t = edge[i].to;<br />
            in[t] --;<br />
            if(in[t] == ){<br />
                q.push(t);<br />
            }<br />
        }<br />
        if(q.size() &gt; )return ;<br />
    }<br />
    return ;<br />
}<br />
int main(){<br />
    int t;<br />
    scanf("%d",&amp;t);<br />
    while(t--){<br />
        scanf("%d%d",&amp;n,&amp;m);<br />
        ind = ;<br />
        while(!s.empty())s.pop();<br />
        memset(pre,-,sizeof(pre));<br />
        for(int i = ; i &lt;= m; i++){<br />
            scanf("%d%d",&amp;x[i],&amp;y[i]);<br />
            add(x[i],y[i]);<br />
        }<br />
        k = ;<br />
        num = ;<br />
        memset(vis,,sizeof(vis));<br />
        memset(dfn,,sizeof(dfn));<br />
        memset(low,,sizeof(low));<br />
        memset(f,,sizeof(f));<br />
        for(int i = ; i &lt;= n; i++){<br />
            if(!dfn[i])dfs(i);<br />
        }<br />
        memset(pre,-,sizeof(pre));<br />
        memset(in,,sizeof(in));<br />
        int ret = ind;<br />
        for(int i = ; i &lt; ret; i++){<br />
            int u = f[edge[i].from];<br />
            int v = f[edge[i].to];<br />
            if(u != v){<br />
                add(u,v);<br />
                in[v] ++;<br />
            }<br />
        }<br />
        if(ok()){<br />
            printf("Yes\n");<br />
        } else{<br />
            printf("No\n");<br />
        }<br />
    }<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kdr679.html">151003-动起来-Javascript</a>
		</li>
						<li><a href="https://www.batexi.com/a/495kjnz9.html">UNION并集运算</a>
		</li>
						<li><a href="https://www.batexi.com/a/r932zkrq.html">asp&period;net 设置页面的默认按钮（敲回车按钮所触发的默认按钮）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zw6618.html">ubuntu 16&period;04 source &lpar;HUST and 163&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd5pn2q.html">BZOJ&lowbar;1029&lowbar;&lbrack;JSOI2007&rsqb;&lowbar;建筑抢修&lowbar;&lpar;贪心&plus;优先队列&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y624eq.html">Java线程间通信--生产者消费者</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvlywoq.html">Centos common software install</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn3ov2q.html">codec ruby和json格式输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zygo59.html">Mina airQQ聊天 服务端篇（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1v2d1q.html">Git 在小团队中的管理流程&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z33nj9.html">网络拓展知识 ACL NAT IPv6</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd4vz49.html">Android项目实战（五十四）：zxing 生成二维码图片去除白色内边距的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gewd108.html">P4014 分配问题  网络流</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdonnj9.html">java ssl 使用不同的加密套件，对性能影响很大</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvgk6j8.html">学习笔记TF021&colon;预测编码、字符级语言建模、ArXiv摘要</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvekpxj9.html">Python初体验（一）&mdash;【配置环境变量】【变量】【input】【条件语句】【循环语句】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpxrzz9.html">搞ACM的你伤不起&lbrack;转载&rsqb; 原作者&colon;RoBa</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v1o4zq.html">c语言的知识与能力自评</a>
		</li>
						<li><a href="https://www.batexi.com/a/90d2z1o8.html">angular-使用iframe做独立页（iframe传值到angular和iframe里请求后台数据）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pm7l379.html">nyoj1087&mdash;&mdash;摆格子&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;【规律题】</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/4qnl0yj9.html">java的构造方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kd42r9.html">第5章 绘图基础&lowbar;5&period;1-5&period;4 GDI绘图</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jxr5gq.html">&lbrack;No000063&rsqb;Python格式化输出</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q26en39.html">javascript获取元素的方法&lbrack;xyyit&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7j1meq.html">MVC 数据验证【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnle239.html">mui禁止横屏显示&comma;仅支持竖屏显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx4gmd9.html">Entity Framework Code  Migration 新建、更新数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx4gvd9.html">sg函数与博弈论2</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1d675q.html">PAT 1006&period; 换个格式输出整数 &lpar;15&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kd7j39.html">傅盛：如何快慢&amp;ldquo&semi;炼&amp;rdquo&semi;金山？（转）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
